---
title: 'SyntaxError: missing formal parameter'
slug: Web/JavaScript/Reference/Errors/Missing_formal_parameter
tags:
  - Error
  - Errors
  - JavaScript
  - SyntaxError
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript exception "missing formal parameter" occurs when your function declaration is missing valid parameters.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox">SyntaxError: missing formal parameter (Firefox)
</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("SyntaxError")}}</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p>"Formal parameter" is a fancy way of saying "function parameter". Your function declaration is missing valid parameters. In the declaration of a function, the parameters must be <a href="/en-US/docs/Glossary/Identifier">identifiers</a>, not any value like numbers, strings, or objects. Declaring functions and calling functions are two separate steps. Declarations require identifier as parameters, and only when calling (invoking) the function, you provide the values the function should use.</p>

<p>In <a href="/en-US/docs/Glossary/JavaScript">JavaScript</a>, identifiers can contain only alphanumeric characters (or "$" or "_"), and may not start with a digit. An identifier differs from a <strong>string</strong> in that a string is data, while an identifier is part of the code.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Provide_proper_function_parameters">Provide proper function parameters</h3>

<p>Function parameters must be identifiers when setting up a function. All these function declarations fail, as they are providing values for their parameters:</p>

<pre class="brush: js example-bad highlight:[1,6,11]">function square(3) {
  return number * number;
};
// SyntaxError: missing formal parameter

function greet("Howdy") {
  return greeting;
};
// SyntaxError: missing formal parameter

function log({ obj: "value"}) {
  console.log(arg)
};
// SyntaxError: missing formal parameter
</pre>

<p>You will need to use identifiers in function declarations:</p>

<pre class="brush: js example-good highlight:[1,5,9]">function square(number) {
  return number * number;
};

function greet(greeting) {
  return greeting;
};

function log(arg) {
  console.log(arg)
};</pre>

<p>You can then call these functions with the arguments you like:</p>

<pre class="brush: js">square(2); // 4

greet("Howdy"); // "Howdy"

log({obj: "value"}); // Object { obj: "value" }
</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li>Other errors regarding formal parameters:
  <ul>
   <li><a href="/en-US/docs/Web/JavaScript/Reference/Errors/Malformed_formal_parameter">SyntaxError: Malformed formal parameter</a></li>
   <li><a href="/en-US/docs/Web/JavaScript/Reference/Errors/Redeclared_parameter">SyntaxError: redeclaration of formal parameter "x"</a></li>
  </ul>
 </li>
</ul>
